<?php

class Model_Helper_PlanBuilder extends Model_Helper_Builder
{
    public function create() {
        $required = ['Year', 'FacultyID', 'ExternalID'];

        if (array_diff($required, array_keys($this->data)))
            throw new InvalidArgumentException('Not enough arguments');

        return new Model_Plan($this->data, false);
    }

    public function & year($year) {
        return $this->createSomeID('Year', $year);
    }

    public function & faculty($facultyID) {
        return $this->createSomeID('FacultyID', $facultyID);
    }

    public function & externalID($externalID) {
        return $this->createSomeID('ExternalID', $externalID);
    }

    public function & createSomeID($name, $value) {
        if (!is_numeric($value) || $value<=0)
            throw new InvalidArgumentException($name.' is incorrect');
        $this->data[$name] = (int) $value;
        return $this;
    }
}
