<?php

class Model_Helper_RecordBookBuilder extends Model_Helper_Builder
{
    public function create() {
        $required = ['StudentID', 'PlanID'];
        if (array_diff($required, array_keys($this->data)))
            throw new InvalidArgumentException('Not enough arguments');

        return new Model_RecordBook($this->data, false);
    }

    public function getPreparedData() {
        $required = ['StudentID', 'PlanID'];
        if (array_diff($required, array_keys($this->data)))
            throw new InvalidArgumentException('Not enough arguments');

        return $this->data;
    }

    public function & studentID($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('student id is incorrect');
        $this->data['StudentID'] = (int) $id;
        return $this;
    }

    public function & planID($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('plan id is incorrect');
        $this->data['PlanID'] = (int) $id;
        return $this;
    }

    public function & facultyID($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Faculty id is incorrect');
        $this->data['FacultyID'] = (int) $id;
        return $this;
    }

    public function & grade($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Grade is incorrect');
        $this->data['GradeID'] = (int) $id;
        return $this;
    }

    public function & group($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Group is incorrect');
        $this->data['GroupID'] = (int) $id;
        return $this;
    }

    public function & externalID($id) {
        $this->data['ExternalID'] = null;
        if (!is_null($id)) {
            $this->data['ExternalID'] = trim($id);
        }
        return $this;
    }
}
